/// WARNING: CODE GENERATED FILE
/// * This file is generated by kfspec2code.
/// * Any changes applied to this file will be lost when a new spec is generated.
use serde::{Deserialize, Serialize};

use kf_protocol_api::ErrorCode;
use kf_protocol_api::Request;

use kf_protocol_derive::Decode;
use kf_protocol_derive::Encode;
use kf_protocol_derive::KfDefault;

// -----------------------------------
// KfCreateAclsRequest
// -----------------------------------

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct KfCreateAclsRequest {
    /// The ACLs that we want to create.
    pub creations: Vec<CreatableAcl>,
}

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct CreatableAcl {
    /// The type of the resource.
    pub resource_type: i8,

    /// The resource name for the ACL.
    pub resource_name: String,

    /// The pattern type for the ACL.
    #[fluvio_kf(min_version = 1)]
    pub resource_pattern_type: i8,

    /// The principal for the ACL.
    pub principal: String,

    /// The host for the ACL.
    pub host: String,

    /// The operation type for the ACL (read, write, etc.).
    pub operation: i8,

    /// The permission type for the ACL (allow, deny, etc.).
    pub permission_type: i8,
}

// -----------------------------------
// KfCreateAclsResponse
// -----------------------------------

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct KfCreateAclsResponse {
    /// The duration in milliseconds for which the request was throttled due to a quota violation,
    /// or zero if the request did not violate any quota.
    pub throttle_time_ms: i32,

    /// The results for each ACL creation.
    pub results: Vec<CreatableAclResult>,
}

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct CreatableAclResult {
    /// The result error, or zero if there was no error.
    pub error_code: ErrorCode,

    /// The result message, or null if there was no error.
    pub error_message: Option<String>,
}

// -----------------------------------
// Implementation - KfCreateAclsRequest
// -----------------------------------

impl Request for KfCreateAclsRequest {
    const API_KEY: u16 = 30;

    const MIN_API_VERSION: i16 = 0;
    const MAX_API_VERSION: i16 = 1;
    const DEFAULT_API_VERSION: i16 = 1;

    type Response = KfCreateAclsResponse;
}
