/// WARNING: CODE GENERATED FILE
/// * This file is generated by kfspec2code.
/// * Any changes applied to this file will be lost when a new spec is generated.
use serde::{Deserialize, Serialize};

use kf_protocol_api::ErrorCode;
use kf_protocol_api::Request;

use kf_protocol_derive::Decode;
use kf_protocol_derive::Encode;
use kf_protocol_derive::KfDefault;

// -----------------------------------
// KfCreateDelegationTokenRequest
// -----------------------------------

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct KfCreateDelegationTokenRequest {
    /// A list of those who are allowed to renew this token before it expires.
    pub renewers: Vec<CreatableRenewers>,

    /// The maximum lifetime of the token in milliseconds, or -1 to use the server side default.
    pub max_lifetime_ms: i64,
}

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct CreatableRenewers {
    /// The type of the Kafka principal.
    pub principal_type: String,

    /// The name of the Kafka principal.
    pub principal_name: String,
}

// -----------------------------------
// KfCreateDelegationTokenResponse
// -----------------------------------

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct KfCreateDelegationTokenResponse {
    /// The top-level error, or zero if there was no error.
    pub error_code: ErrorCode,

    /// The principal type of the token owner.
    pub principal_type: String,

    /// The name of the token owner.
    pub principal_name: String,

    /// When this token was generated.
    pub issue_timestamp_ms: i64,

    /// When this token expires.
    pub expiry_timestamp_ms: i64,

    /// The maximum lifetime of this token.
    pub max_timestamp_ms: i64,

    /// The token UUID.
    pub token_name: String,

    /// HMAC of the delegation token.
    pub hmac: Vec<u8>,

    /// The duration in milliseconds for which the request was throttled due to a quota violation,
    /// or zero if the request did not violate any quota.
    pub throttle_time_ms: i32,
}

// -----------------------------------
// Implementation - KfCreateDelegationTokenRequest
// -----------------------------------

impl Request for KfCreateDelegationTokenRequest {
    const API_KEY: u16 = 38;

    const MIN_API_VERSION: i16 = 0;
    const MAX_API_VERSION: i16 = 1;
    const DEFAULT_API_VERSION: i16 = 1;

    type Response = KfCreateDelegationTokenResponse;
}
