/// WARNING: CODE GENERATED FILE
/// * This file is generated by kfspec2code.
/// * Any changes applied to this file will be lost when a new spec is generated.
use serde::{Deserialize, Serialize};

use kf_protocol_api::ErrorCode;
use kf_protocol_api::Request;

use kf_protocol_derive::Decode;
use kf_protocol_derive::Encode;
use kf_protocol_derive::KfDefault;

// -----------------------------------
// KfElectPreferredLeadersRequest
// -----------------------------------

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct KfElectPreferredLeadersRequest {
    /// The topic partitions to elect the preferred leader of.
    pub topic_partitions: Option<Vec<TopicPartitions>>,

    /// The time in ms to wait for the election to complete.
    #[fluvio_kf()]
    pub timeout_ms: i32,
}

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct TopicPartitions {
    /// The name of a topic.
    pub topic: String,

    /// The partitions of this topic whose preferred leader should be elected
    pub partition_id: Vec<i32>,
}

// -----------------------------------
// KfElectPreferredLeadersResponse
// -----------------------------------

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct KfElectPreferredLeadersResponse {
    /// The duration in milliseconds for which the request was throttled due to a quota violation,
    /// or zero if the request did not violate any quota.
    pub throttle_time_ms: i32,

    /// The error code, or 0 if there was no error.
    pub replica_election_results: Vec<ReplicaElectionResult>,
}

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct ReplicaElectionResult {
    /// The topic name
    pub topic: String,

    /// The results for each partition
    pub partition_result: Vec<PartitionResult>,
}

#[derive(Encode, Decode, Serialize, Deserialize, KfDefault, Debug)]
pub struct PartitionResult {
    /// The partition id
    pub partition_id: i32,

    /// The result error, or zero if there was no error.
    pub error_code: ErrorCode,

    /// The result message, or null if there was no error.
    pub error_message: Option<String>,
}

// -----------------------------------
// Implementation - KfElectPreferredLeadersRequest
// -----------------------------------

impl Request for KfElectPreferredLeadersRequest {
    const API_KEY: u16 = 43;

    const MIN_API_VERSION: i16 = 0;
    const MAX_API_VERSION: i16 = 0;
    const DEFAULT_API_VERSION: i16 = 0;

    type Response = KfElectPreferredLeadersResponse;
}
